Name:           openlmi-providers
Version:        0.0.19
Release:        1%{?dist}
Summary:        Set of basic CIM providers

License:        LGPLv2+
URL:            http://fedorahosted.org/openlmi/
Source0:        http://fedorahosted.org/released/openlmi-providers/%{name}-%{version}.tar.gz

# Upstream name has been changed from cura-providers to openlmi-providers
Provides:       cura-providers%{?_isa} = %{version}-%{release}
Obsoletes:      cura-providers < 0.0.10-1

BuildRequires:  cmake
BuildRequires:  konkretcmpi-devel >= 0.9.0-2
BuildRequires:  sblim-cmpi-devel
BuildRequires:  cim-schema
# For openlmi-power
BuildRequires:  upower-devel
# For openlmi-fan
BuildRequires:  lm_sensors-devel
# For openlmi-account
BuildRequires:  libuser-devel
BuildRequires:  python2-devel
# For openlmi-hardware
BuildRequires:  pciutils-devel
# For openlmi-register-pegasus script
Requires:       python2
# sblim-sfcb or tog-pegasus
# (required to be present during install/uninstall for registration)
Requires:       cim-server
Requires(pre):  cim-server
Requires(preun): cim-server
Requires(post): cim-server

# XXX
# Just because we have wired python's scripts
# Remove in future
BuildRequires:  python-setuptools

%description
%{name} is set of (usually) small CMPI providers (agents) for basic
monitoring and management of host system using Common Information
Model (CIM).

%package devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}
Provides:       cura-providers-devel%{?_isa} = %{version}-%{release}
Obsoletes:      cura-providers-devel < 0.0.10-1

%description devel
%{summary}.

%package -n openlmi-fan
Summary:        CIM provider for controlling fans
Requires:       %{name}%{?_isa} = %{version}-%{release}
Provides:       cura-fan%{?_isa} = %{version}-%{release}
Obsoletes:      cura-fan < 0.0.10-1

%description -n openlmi-fan
%{summary}.


%package -n openlmi-powermanagement
Summary:        Power management CIM provider
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:       upower
# For Linux_ComputerSystem
Requires:       sblim-cmpi-base
Provides:       cura-powermanagement%{?_isa} = %{version}-%{release}
Obsoletes:      cura-powermanagement < 0.0.10-1

%description -n openlmi-powermanagement
%{summary}.


%package -n openlmi-service
Summary:        CIM provider for controlling system services
Requires:       %{name}%{?_isa} = %{version}-%{release}
Provides:       cura-service%{?_isa} = %{version}-%{release}
Obsoletes:      cura-service < 0.0.10-1

%description -n openlmi-service
%{summary}.

%package -n openlmi-account
Summary:        CIM provider for managing accounts on system
Requires:       %{name}%{?_isa} = %{version}-%{release}
# For Linux_ComputerSystem
Requires:       sblim-cmpi-base
Provides:       cura-account%{?_isa} = %{version}-%{release}
Obsoletes:      cura-account < 0.0.10-1

%description -n openlmi-account
%{summary}.

%package -n openlmi-hardware
Summary:        CIM provider for hardware on system
Requires:       %{name}%{?_isa} = %{version}-%{release}
# For Linux_ComputerSystem
Requires:       sblim-cmpi-base

%description -n openlmi-hardware
%{summary}.

%package -n openlmi-python
Summary:        Python namespace package for pywbem providers
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch
Requires:       python-setuptools
Requires:       cmpi-bindings-pywbem

%description -n openlmi-python
The openlmi-python package contains python namespace package for
all openlmi python providers using cmpi-bindings-pywbem.

%package -n openlmi-software
Summary:        CIM providers for software management
Requires:       %{name} = %{version}-%{release}
Requires:       openlmi-python = %{version}-%{release}
Provides:       cura-software = %{version}-%{release}
Obsoletes:      cura-software < 0.0.10-1
BuildArch:      noarch

Requires:       yum
# For Linux_ComputerSystem
Requires:       sblim-cmpi-base

%description -n openlmi-software
The openlmi-software package contains CMPI providers for management of software
through yum package manager with Common Information Managemen (CIM) protocol.

The providers can be registered in any CMPI-aware CIMOM, both OpenPegasus and
SFCB were tested.

%package -n openlmi-logicalfile
Summary:        CIM provider for reading files and directories
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:       sblim-cmpi-base

%description -n openlmi-logicalfile
%{summary}.


%prep
%setup -q

%build
mkdir -p %{_target_platform}
pushd %{_target_platform}
%{cmake} ..
popd

make %{?_smp_mflags} -C %{_target_platform}

pushd src/python
%{__python} setup.py build
popd # src/python
# for software providers
pushd src/software
%{__python} setup.py build
popd # src/software

%install
make install/fast DESTDIR=$RPM_BUILD_ROOT -C %{_target_platform}

# XXX
# Remove pythonies
# Don't forget to remove this dirty hack in the future
rm -rf "$RPM_BUILD_ROOT"/usr/bin/*.py
rm -rf "$RPM_BUILD_ROOT"/usr/lib/python*

pushd src/python
%{__python} setup.py install -O1 --skip-build --root $RPM_BUILD_ROOT
popd # src/python

# for software providers
pushd src/software
%{__python} setup.py install -O1 --skip-build --root $RPM_BUILD_ROOT
popd # src/software
cp mof/LMI_Software.reg $RPM_BUILD_ROOT/%{_datadir}/%{name}/


%files
%doc README COPYING
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/LMI_Qualifiers.mof
%{_libdir}/libopenlmicommon.so.*
%attr(755, root, root) %{_bindir}/openlmi-mof-register
%attr(755, root, root) %{_libexecdir}/openlmi-register-pegasus

%files devel
%{_bindir}/openlmi-doc-class2rst
%{_bindir}/openlmi-doc-class2uml
%{_libdir}/libopenlmicommon.so
%{_includedir}/openlmi/globals.h
%{_datadir}/cmake/Modules/OpenLMIMacros.cmake
%{_datadir}/cmake/Modules/FindCMPI.cmake
%{_datadir}/cmake/Modules/FindKonkretCMPI.cmake

%files -n openlmi-fan
%doc README COPYING
%{_libdir}/cmpi/libcmpiLMI_Fan.so
%{_datadir}/%{name}/LMI_Fan.mof
%{_datadir}/%{name}/LMI_Fan.reg

%files -n openlmi-powermanagement
%doc README COPYING
%{_libdir}/cmpi/libcmpiLMI_PowerManagement.so
%{_datadir}/%{name}/LMI_PowerManagement.mof
%{_datadir}/%{name}/LMI_PowerManagement.reg

%files -n openlmi-service
%doc README COPYING
%attr(755, root, root) %{_libexecdir}/servicedisc.sh
%attr(755, root, root) %{_libexecdir}/serviceutil.sh
%{_libdir}/cmpi/libcmpiLMI_Service.so
%{_datadir}/%{name}/LMI_Service.mof
%{_datadir}/%{name}/LMI_Service.reg

%files -n openlmi-account
%doc README COPYING
%{_libdir}/cmpi/libcmpiLMI_Account.so
%{_datadir}/%{name}/LMI_Account.mof
%{_datadir}/%{name}/LMI_Account.reg
%attr(755, root, root) %{_libexecdir}/pegasus/cmpiLMI_Account-cimprovagt

%files -n openlmi-hardware
%doc README COPYING
%{_libdir}/cmpi/libcmpiLMI_Hardware.so
%{_datadir}/%{name}/LMI_Hardware.mof
%{_datadir}/%{name}/LMI_Hardware.reg

%files -n openlmi-python
%doc README COPYING
%dir %{python_sitelib}/openlmi
%{python_sitelib}/openlmi-*
%dir %{python_sitelib}/openlmi/common
%{python_sitelib}/openlmi/common/*.py
%{python_sitelib}/openlmi/common/*.py[co]

%files -n openlmi-software
%doc README COPYING
%dir %{python_sitelib}/openlmi/software
%{python_sitelib}/openlmi/software/*
%{python_sitelib}/openlmi_software-*

%{_datadir}/%{name}/LMI_Software.mof
%{_datadir}/%{name}/LMI_Software.reg

%files -n openlmi-logicalfile
%doc README COPYING
%{_libdir}/cmpi/libcmpiLMI_LogicalFile.so
%{_datadir}/%{name}/LMI_LogicalFile.mof
%{_datadir}/%{name}/LMI_LogicalFile.reg


%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%pre -n openlmi-fan
# If upgrading, deregister old version
if [ "$1" -gt 1 ]; then
    %{_bindir}/openlmi-mof-register unregister \
        %{_datadir}/%{name}/LMI_Fan.mof \
        %{_datadir}/%{name}/LMI_Fan.reg \
        > /dev/null 2>&1 || :;
fi

%pre -n openlmi-powermanagement
if [ "$1" -gt 1 ]; then
    %{_bindir}/openlmi-mof-register unregister \
        %{_datadir}/%{name}/LMI_PowerManagement.mof \
        %{_datadir}/%{name}/LMI_PowerManagement.reg \
        > /dev/null 2>&1 || :;
fi

%pre -n openlmi-service
if [ "$1" -gt 1 ]; then
    %{_bindir}/openlmi-mof-register unregister \
        %{_datadir}/%{name}/LMI_Service.mof \
        %{_datadir}/%{name}/LMI_Service.reg \
        > /dev/null 2>&1 || :;
fi

%pre -n openlmi-account
if [ "$1" -gt 1 ]; then
    %{_bindir}/openlmi-mof-register unregister \
        %{_datadir}/%{name}/LMI_Account.mof \
        %{_datadir}/%{name}/LMI_Account.reg \
        > /dev/null 2>&1 || :;
fi

%pre -n openlmi-software
if [ "$1" -gt 1 ]; then
    %{_bindir}/openlmi-mof-register unregister \
        %{_datadir}/%{name}/LMI_Software.mof \
        %{_datadir}/%{name}/LMI_Software.reg \
        > /dev/null 2>&1 || :;
fi

%pre -n openlmi-logicalfile
if [ "$1" -gt 1 ]; then
    %{_bindir}/openlmi-mof-register unregister \
        %{_datadir}/%{name}/LMI_LogicalFile.mof \
        %{_datadir}/%{name}/LMI_LogicalFile.reg \
        > /dev/null 2>&1 || :;
fi

%post -n openlmi-fan
# Register Schema and Provider
if [ "$1" -ge 1 ]; then
    %{_bindir}/openlmi-mof-register register \
        %{_datadir}/%{name}/LMI_Fan.mof \
        %{_datadir}/%{name}/LMI_Fan.reg \
        > /dev/null 2>&1 || :;
fi

%post -n openlmi-powermanagement
if [ "$1" -ge 1 ]; then
    %{_bindir}/openlmi-mof-register register \
        %{_datadir}/%{name}/LMI_PowerManagement.mof \
        %{_datadir}/%{name}/LMI_PowerManagement.reg \
        > /dev/null 2>&1 || :;
fi

%post -n openlmi-service
if [ "$1" -ge 1 ]; then
    %{_bindir}/openlmi-mof-register register \
        %{_datadir}/%{name}/LMI_Service.mof \
        %{_datadir}/%{name}/LMI_Service.reg \
        > /dev/null 2>&1 || :;
fi

%post -n openlmi-account
if [ "$1" -ge 1 ]; then
    %{_bindir}/openlmi-mof-register register \
        %{_datadir}/%{name}/LMI_Account.mof \
        %{_datadir}/%{name}/LMI_Account.reg \
        > /dev/null 2>&1 || :;
fi

%post -n openlmi-software
if [ "$1" -ge 1 ]; then
    %{_bindir}/openlmi-mof-register register \
        %{_datadir}/%{name}/LMI_Software.mof \
        %{_datadir}/%{name}/LMI_Software.reg \
        > /dev/null 2>&1 || :;
fi

%post -n openlmi-logicalfile
if [ "$1" -gt 1 ]; then
    %{_bindir}/openlmi-mof-register register \
        %{_datadir}/%{name}/LMI_LogicalFile.mof \
        %{_datadir}/%{name}/LMI_LogicalFile.reg \
        > /dev/null 2>&1 || :;
fi

%preun -n openlmi-fan
# Deregister only if not upgrading
if [ "$1" -eq 0 ]; then
    %{_bindir}/openlmi-mof-register unregister \
        %{_datadir}/%{name}/LMI_Fan.mof \
        %{_datadir}/%{name}/LMI_Fan.reg \
        > /dev/null 2>&1 || :;
fi

%preun -n openlmi-powermanagement
if [ "$1" -eq 0 ]; then
    %{_bindir}/openlmi-mof-register unregister \
        %{_datadir}/%{name}/LMI_PowerManagement.mof \
        %{_datadir}/%{name}/LMI_PowerManagement.reg \
        > /dev/null 2>&1 || :;
fi

%preun -n openlmi-service
if [ "$1" -eq 0 ]; then
    %{_bindir}/openlmi-mof-register unregister \
        %{_datadir}/%{name}/LMI_Service.mof \
        %{_datadir}/%{name}/LMI_Service.reg \
        > /dev/null 2>&1 || :;
fi

%preun -n openlmi-account
if [ "$1" -eq 0 ]; then
    %{_bindir}/openlmi-mof-register unregister \
        %{_datadir}/%{name}/LMI_Account.mof \
        %{_datadir}/%{name}/LMI_Account.reg \
        > /dev/null 2>&1 || :;
fi

%preun -n openlmi-software
if [ "$1" -eq 0 ]; then
    %{_bindir}/openlmi-mof-register unregister \
        %{_datadir}/%{name}/LMI_Software.mof \
        %{_datadir}/%{name}/LMI_Software.reg \
        > /dev/null 2>&1 || :;
fi

%preun -n openlmi-logicalfile
if [ "$1" -gt 1 ]; then
    %{_bindir}/openlmi-mof-register unregister \
        %{_datadir}/%{name}/LMI_LogicalFile.mof \
        %{_datadir}/%{name}/LMI_LogicalFile.reg \
        > /dev/null 2>&1 || :;
fi


%changelog
* Mon Mar 11 2013 Radek Novacek <rnovacek@redhat.com> 0.0.19-1
- Version 0.0.19
- Add LogicalFile provider
- Require konkretcmpi >= 0.9.0-2
- Install openlmi-doc-class2* scripts

* Thu Feb 14 2013 Radek Novacek <rnovacek@redhat.com> 0.0.18-2
- Add upstream patch with improvements of OpenLMIMacros.cmake
- Add requirement for cim-server also to pre, preun and post

* Mon Feb 04 2013 Michal Minar <miminar@redhat.com> 0.0.18-1
- Version 0.0.18

* Tue Jan 22 2013 Roman Rakus <rrakus@redhat.com> - 0.0.17-1
- Version 0.0.17

* Wed Jan 16 2013 Roman Rakus <rrakus@redhat.com> - 0.0.16-1
- Version 0.0.16

* Fri Dec 14 2012 Radek Novacek <rnovacek@redhat.com> 0.0.15-4
- Allow number in class name in OpenLMIMacros.cmake

* Fri Dec 07 2012 Radek Novacek <rnovacek@redhat.com> 0.0.15-3
- Add mof file with definition of 'Implemented' qualifier

* Fri Nov 23 2012 Radek Novacek <rnovacek@redhat.com> 0.0.15-2
- Add missing dependency on sblim-cmpi-base for powermanagement and account

* Tue Nov 13 2012 Radek Novacek <rnovacek@redhat.com> 0.0.15-1
- Version 0.0.15
- Upstream changed license from GPLv2+ to LGPLv2+

* Thu Nov 08 2012 Michal Minar <miminar@redhat.com> 0.0.14-1
- Version 0.0.14
- Added python subpackage for python providers

* Wed Oct 31 2012 Roman Rakus <rrakus@redhat.com> - 0.0.12-2
- Requires fixed konkretcmpi >= 0.8.7-7

* Thu Oct 25 2012 Roman Rakus <rrakus@redhat.com> - 0.0.12-1
- Version 0.0.12

* Thu Oct 25 2012 Radek Novacek <rnovacek@redhat.com> 0.0.10-2
- Remove %isa from obsoletes

* Mon Oct 22 2012 Radek Novacek <rnovacek@redhat.com> - 0.0.10-1
- Package rename to openlmi-providers (instead of cura-providers)
- helper scripts moved from usr/share to proper location
- Version 0.0.10

* Sat Oct 13 2012 Michal Minar <miminar@redhat.com> - 0.0.9-1
- Version 0.0.9
- Renamed cura-yum subpackage to cura-software

* Sun Oct 07 2012 Michal Minar <miminar@redhat.com> - 0.0.8-1
- Version 0.0.8

* Wed Oct 03 2012 Michal Minar <miminar@redhat.com> - 0.0.7-1
- Version 0.0.7

* Thu Sep 27 2012 Michal Minar <miminar@redhat.com> - 0.0.6-1
- Added yum software management providers.

* Thu Sep 27 2012 Roman Rakus <rrakus@redhat.com> - 0.0.5-1
- Version 0.0.5

* Tue Sep 18 2012 Roman Rakus <rrakus@redhat.com> - 0.0.4-1
- Version 0.0.4
- Remove python parts. There are not intended to be present here.

* Mon Aug 27 2012 Radek Novacek <rnovacek@redhat.com> 0.0.3-1
- Version 0.0.3
- Rename prefix from Cura_ to LMI_
- Add more development files

* Tue Aug 14 2012 Roman Rakus <rrakus@redhat.com> - 0.0.2-1
- Version 0.0.2 which includes account manager

* Fri Aug 03 2012 Radek Novacek <rnovacek@redhat.com> 0.0.1-2
- BR: cim-schema
- Don't clean buildroot in install
- Fix typo

* Tue Jul 31 2012 Radek Novacek <rnovacek@redhat.com> 0.0.1-1
- Initial package

